#import <React/RCTBridgeModule.h>

@interface RCT_EXTERN_MODULE(AppconsentClearReactnative, NSObject)

RCT_EXTERN_METHOD(configureWith: (NSString *)appKey forceApplyGDPR: (BOOL)gdpr forceATT: (BOOL)att)
RCT_EXTERN_METHOD(present: (BOOL)force)
RCT_EXTERN_METHOD(checkForUpdate: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock)reject)
RCT_EXTERN_METHOD(isGDPRCountry: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(consentAlreadyGiven: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(consentGiven: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(clearConsent)

RCT_EXTERN_METHOD(extraConsentableAllowed: (NSString *)extraId resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(extraVendorAllowed: (NSString *)extraId resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(extraFloatingPurposeAllowed: (NSString *)extraId resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(setConsentableConsent: (NSDictionary *)values resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(setExtraConsentableConsent: (NSDictionary *)values resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))

RCT_EXTERN_METHOD(getExternalIds: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(setExternalIds: (NSDictionary *)ids resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(saveExternalIds: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))

// Only iOS
RCT_EXTERN_METHOD(getForceATT: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(appTrackingIsAvailable: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(appTrackingAuthorizationGiven: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(appTrackingAuthorizationStatus: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))

// Deprecated
RCT_EXTERN_METHOD(consentableAllowedByObjectId: (NSString *)objectId resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(consentableAllowedByIABId: (NSString *)iabId type:(NSInteger)type resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(vendorAllowedByIABId: (NSString *)iabId resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(stackAllowedByIABId: (NSString *)iabId resolver:(RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(getAppKey: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
RCT_EXTERN_METHOD(getForceApplyGDPR: (RCTPromiseResolveBlock)resolve rejecter:(RCTPromiseRejectBlock))
@end
